#include <Servo.h>
#include <Ethernet.h>
#include <SPI.h>

const int pinv=2;
float temp;
int pin=0;
const int LED=13;
int polozaj=0;
int stanje=0;
Servo myservo;
int check = 0;
int internet = 0;

byte mac[]={ 0x90, 0xA2, 0xDA, 0x0D, 0xA6, 0x0A };   //mac adresa od shielda
//IPAddress ip { 169,254,74,10}; 
IPAddress ip {161, 53, 64, 51};   //na FER-u 
//byte gateway[]= { 10, 2, 0, 1};               
byte gateway[]= { 163, 53, 73, 1};
byte subnet[] = {255, 255, 0, 0};

EthernetServer server(80);      // server port

String readString;
/////////////////////////

void setup() {

  // start Ethernet
  Ethernet.begin (mac, ip, gateway, subnet);
  server.begin();

  Serial.begin(9600);
  myservo.attach(9);  //pridruzujem pin 9 kao kontrolni pin za servo motor
  pinMode(LED,OUTPUT);
  pinMode(pinv,INPUT);
  pinMode(8,OUTPUT);
  
}
///////////////

void loop() {

  // Kreiranje spajanja za klijenta
  
  EthernetClient client = server.available();
  stanje=digitalRead(pinv);
  temp=analogRead(pin);
  temp=(temp*5.0*100.0)/1024.0;
  
  //Serial.print("temperatura prostora je: ");
 // Serial.println(temp);
  //Serial.print("*C*");
 // Serial.println();
  //Serial.println(temp);
  if(client){
      while(client.connected()){
      if(client.available()){
        char c = client.read();

        if(readString.length() < 100){

          readString +=c;
          Serial.print(c);
        }

        //ako je HTTP zahtjev gotov
        if (c == '\n'){
        
            Serial.println(readString);   //prikazi na ekranu

          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
         client.println("Refresh: 5");          // osvjezavaj svakih 5 sekundi
          client.println();
           client.print("<body style=background-color:gainsboro>");
          client.println("<html>");
          client.println("<head>");
          client.println("<meta name='apple-mobile-web-app-capable' content='yes' />");
          client.println("<meta name='apple-mobile-web-app-status-bar-style' content='black-translucent' />");
          client.println("<link rel='stylesheet' type='text/css' href='http://randomnerdtutorials.com/ethernetcss.css' />");

              
          client.println("<title>Arduino upravljanje</title>");    // naziv kartice u pretrazivacu
          client.println("</head>");
          client.println("<body>");

         
          client.println("<p><font color='navy'><H1> Projekt 'Pametne kuce': Pametni prozor</font></H1>");     // najbitniji header definiramo s H1
          client.println("<hr />");                             // odvojeno linijom
          client.println("<p><font color='blue'><H2> Upravljanje prozorom </font></H2> ");
         
          client.println("<p>\n<p>");
           client.println("Otvorite prozor: <a href=\"/?on4\"\" style=background-color:steelblue >OTVORI</a>");
         // client.println("Otvorite prozor: <input type=button value=OTVORI style=color:blue onmousedown=location.href='/?on4'>"); 
          
          client.println("<p>\n<p>");
          client.println("Zatvorite prozor: <a href=\"/?off5\"\" style=background-color:steelblue >ZATVORI</a>");
         // client.println("Zatvorite prozor:<input type=button value=ZATVORI style=color:red onmousedown=location.href='/?off5'>");
         
          client.println("<p>\n<p>");
          client.println("Stavi sustav u automatski nacin rada: <a href=\"/?aut\"\" style=background-color:steelblue>AUTOMATIZIRAJ</a>");
          //client.println("Stavi sustav u automatski nacin rada: <input type=button  value=AUTOMATIZIRAJ style=color:green onmousedown=location.href='/?aut'>");
          client.println("<hr />"); 
          client.println("<br />");
          client.println("<p><font color='blue'><H2> OBAVIJESTI </font></H2> ");
          client.println("<p>Trenutna temperatura je: ");
          client.println(temp);
          client.println(" *C");
          client.println("</p");
          client.println("<font size='5'>Prozor je trenutno: "); 
          
          if(readString.indexOf('on4') >0 ){
            
          client.println("<font color='blue' size='5'>OTVOREN");
          }
          else if(readString.indexOf('off5') >0){ 
          client.println("<font color='red' size='5'>ZATVOREN"); 
          }
          else if(readString.indexOf('aut') >0){ 
          client.println("<font color='darkgreen' size='5'>AUTOMATIZIRAN"); 
          }
          client.println("<hr />");
          client.println("<p>\n<p>");
          client.println("<p><font color='grey' size'1'>by Boris Primorac</font><p> ");
          client.println("</body>");
          client.println("</html>");
           
          delay(1);
          //stopping client
          client.stop();
           Serial.println("klijent je odspojen");

        // kontroliranje motora

        if(readString.indexOf('on4') >0)
          {
             Serial.println(readString.indexOf('on4'));
            polozaj = 40;
            myservo.write(polozaj);       //otvori prozor   
            check = 0;
            
            
          }
           if(readString.indexOf('off5') >0)
          {
             Serial.println(readString.indexOf('off5'));
            polozaj = 150;
            myservo.write(polozaj);      // zatvori prozor
            check = 0;
            
          }
         if(readString.indexOf('aut') >0){ 
           check=1;
           Serial.println(check);       
          }
                 
          //clearing string for next read
          readString="";     
        }
      }
    }
  }
     // if(temp>30)//slucaj kada pada kisa
          if(check == 1){
            
            if(stanje ==HIGH){
              tone(8,2000,100);   //signaliziraj pad kise
              delay(500);
              polozaj=150;          // zatvori prozor bez obzira na temp
              myservo.write(polozaj);
//           
           }                 
             else {           // slucaj kada ne pada kisa
            
        
                  if(temp>32 ){    // ako je temp veca od 30 ,otvori
                  //digitalWrite(LED,HIGH);
                  polozaj=40;      // otvori prozor ako je temp>30 a ne pada kisa
                  myservo.write(polozaj);
                  }
                  else{                     
                  //digitalWrite(LED,LOW); //ako je temp unutra manja od 30 i ne pada kisa zatvori prozor
                  delay(1000);
                  polozaj=150;
                  myservo.write(polozaj);
                 }
                 Serial.println(temp);
             }
                //Serial.println(temp);
                  // delay(3000);
 }
}
